static char RcsId[] = "$Header: getrange.c,v 1.1 93/10/29 22:54:43 will Exp $";
#define D(x)
#include <stdio.h>
#include <ctype.h>
#include <string.h>

extern char *prog;

/***************************************************************************/
int getrange(range, first, last, nstep)
/***************************************************************************/
    /* Gets a range from a string.  Ranges are of the form		*/
    /*		first-last[/nstep]   or   first:length[/nstep]		*/
    /* All numbers must be >= 0 */
    /* `last' can be a $-sign, in which case -1 is returned		*/
    /* It verifies that lengths and nsteps are positive			*/
    /* If a range expression cannot be compiled, exit(1) is called */
    /* Prints error messages to stderr */
    /* Returns:
	-1 -- internal error
	0 -- valid range
	1 -- invalid range syntax
	2 -- form is first-last, and last < first
	3 -- form is first:length, and length < 1
	4 -- step size not positive
    */

char *range;	/* range string to interpret.  */
long *first;	/* returned with first character in range */
long *last;	/* returned with last character in range; returned with */
		/* -1 if last is a $-sign */
long *nstep;	/* returned with a step count */
{
    char *s;
    char *n1;
    char sep;
    char *n2;
    char *step;

    char *buf;
    char *malloc();

    buf = malloc(strlen(range) + 1);
    if (buf == NULL)
	return -1;
    strcpy(buf, range);

    s = buf;
    while (isspace(*s))
	s++;

    n1 = s;
    if (!isdigit(*s))
	return 1;
    while (isdigit(*s))
	s++;
    while (isspace(*s))
	s++;

    sep = *s;
    if (sep != ':' && sep != '-')
	return 1;
    *s = '\0';
    s++;
    while (isspace(*s))
	s++;

    n2 = s;
    if (*s == '$') {
	s++;
    } else if (!isdigit(*s)) {
	return 1;
    } else {
	while (isdigit(*s))
	    s++;
    }
    while (isspace(*s))
	s++;

    if (*s == '\0') {
	step = NULL;
    } else if (*s == '-') {
	return 4;
    } else if (*s != '/') {
	return 1;
    } else {
	*s++ = '\0';
	while (isspace(*s))
	    s++;
	if (!isdigit(*s))
	    return 1;
	step = s;
	while (isdigit(*s))
	    s++;
	while (isspace(*s))
	    s++;
	if (*s != '\0')
	    return 1;
    }

    (void) sscanf(n1, "%ld", first);
    if (*n2 == '$')
	*last = -1;
    else
	(void) sscanf(n2, "%ld", last);
    if (step == NULL)
	*nstep = -1;
    else
	(void) sscanf(step, "%ld", nstep);

    if (sep == ':')	{
	/* *last is really a length */
	if (*last < 1)
	    return 3;
	*last = *first + *last - 1;
    } else if (*last != -1 && *last < *first) {
	return 2;
    }
    return 0;
}
    

