static char RcsId[] = "$Header: replace.c,v 1.1 93/10/29 22:54:45 will Exp $";
#include <stdio.h>

extern char *prog;

/****************************************************************************/
void replace(fp, buf, bufsize, range, first, last, nstep, size)
/****************************************************************************/

    /* Reads data from stdin and writes it to a specified location in output */

FILE *fp;	/* File upon which replacement is to be done */
char *buf;	/* Copy buffer */
int bufsize;	/* Copy buffer size */
char *range;	/* Range string entered by user; used for error messages */
int first;	/* first byte to copy (first byte in file is #1) */
int last;	/* last byte to copy */
int nstep;	/* Step size for repetitions of first-last */
int size;	/* File size; used for stopping repetitions */
{
    int k, len, toread, nread;
    int firstc;


    len = last + 1 - first;
    firstc = first;
    do {
	if (fseek(fp, (long) (first-1), 0) == -1) {
	    (void) fprintf(stderr,
		    "%s: failed to fseek to beginning of range `%s': ",
		    prog, range);
	    perror("");
	    exit(1);
	}

	for (nread=0; nread < len; ) {
	    toread = len-nread;
	    toread = (toread > bufsize) ? bufsize : toread;
	    if ((k = fread(buf, 1, toread, stdin)) > 0) {
		nread += k;
	    } else {
		if (nread > 0) {
		    (void) fprintf(stderr,
			"%s: only read %d chars from stdin for range `%s'\n",
					prog, nread, range);
		    if (nstep)
			(void) fprintf(stderr,
	"Stopping after %d full and 1 partial replacements for this range.\n",
						(first-firstc)/nstep);
		} else {
		    (void) fprintf(stderr,
			    "%s: couldn't read data for range request `%s'\n",
					prog, range);
		    if (nstep)
			(void) fprintf(stderr,
			"Stopping after %d full replacements for this range.\n",
						(first-firstc)/nstep);
		}
		if (ferror(fp))
		    perror("");
		exit(1);
	    }
	    if (fwrite(buf, 1, k, fp) != k) {
		(void) fprintf(stderr,
			"%s: couldn't write data from range request `%s'\n",
			prog, range);
		if (nstep)
		    (void) fprintf(stderr,
			"Quitting after %d full replacements for this range.\n",
						(first-firstc)/nstep);
		if (ferror(fp))
		    perror("");
		exit(1);
	    }
	}

	first += nstep;
	last += nstep;
    } while (last <= size && nstep > 0);
}
